/* Adapter.c generated by valac 0.42.6, the Vala compiler
 * generated from Adapter.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define BLUETOOTH_SERVICES_TYPE_ADAPTER (bluetooth_services_adapter_get_type ())
#define BLUETOOTH_SERVICES_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapter))
#define BLUETOOTH_SERVICES_IS_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER))
#define BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), BLUETOOTH_SERVICES_TYPE_ADAPTER, BluetoothServicesAdapterIface))

typedef struct _BluetoothServicesAdapter BluetoothServicesAdapter;
typedef struct _BluetoothServicesAdapterIface BluetoothServicesAdapterIface;

#define BLUETOOTH_SERVICES_TYPE_ADAPTER_PROXY (bluetooth_services_adapter_proxy_get_type ())
typedef GDBusProxy BluetoothServicesAdapterProxy;
typedef GDBusProxyClass BluetoothServicesAdapterProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _BluetoothServicesAdapterStartDiscoveryReadyData BluetoothServicesAdapterStartDiscoveryReadyData;
typedef struct _BluetoothServicesAdapterStopDiscoveryReadyData BluetoothServicesAdapterStopDiscoveryReadyData;

struct _BluetoothServicesAdapterIface {
	GTypeInterface parent_iface;
	void (*remove_device) (BluetoothServicesAdapter* self, const char* device, GError** error);
	void (*set_discovery_filter) (BluetoothServicesAdapter* self, GHashTable* properties, GError** error);
	void (*start_discovery) (BluetoothServicesAdapter* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*start_discovery_finish) (BluetoothServicesAdapter* self, GAsyncResult* _res_, GError** error);
	void (*stop_discovery) (BluetoothServicesAdapter* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*stop_discovery_finish) (BluetoothServicesAdapter* self, GAsyncResult* _res_, GError** error);
	gchar** (*get_UUIDs) (BluetoothServicesAdapter* self, int* result_length1);
	gboolean (*get_discoverable) (BluetoothServicesAdapter* self);
	void (*set_discoverable) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_discovering) (BluetoothServicesAdapter* self);
	gboolean (*get_pairable) (BluetoothServicesAdapter* self);
	void (*set_pairable) (BluetoothServicesAdapter* self, gboolean value);
	gboolean (*get_powered) (BluetoothServicesAdapter* self);
	void (*set_powered) (BluetoothServicesAdapter* self, gboolean value);
	gchar* (*get_address) (BluetoothServicesAdapter* self);
	gchar* (*get_alias) (BluetoothServicesAdapter* self);
	void (*set_alias) (BluetoothServicesAdapter* self, const gchar* value);
	gchar* (*get_modalias) (BluetoothServicesAdapter* self);
	gchar* (*get_name) (BluetoothServicesAdapter* self);
	guint (*get_class) (BluetoothServicesAdapter* self);
	guint (*get_discoverable_timeout) (BluetoothServicesAdapter* self);
	guint (*get_pairable_timeout) (BluetoothServicesAdapter* self);
};

struct _BluetoothServicesAdapterStartDiscoveryReadyData {
	GDBusMethodInvocation* _invocation_;
};

struct _BluetoothServicesAdapterStopDiscoveryReadyData {
	GDBusMethodInvocation* _invocation_;
};



GType bluetooth_services_adapter_proxy_get_type (void) G_GNUC_CONST;
guint bluetooth_services_adapter_register_object (void* object,
                                                  GDBusConnection* connection,
                                                  const gchar* path,
                                                  GError** error);
GType bluetooth_services_adapter_get_type (void) G_GNUC_CONST;
void bluetooth_services_adapter_remove_device (BluetoothServicesAdapter* self,
                                               const char* device,
                                               GError** error);
void bluetooth_services_adapter_set_discovery_filter (BluetoothServicesAdapter* self,
                                                      GHashTable* properties,
                                                      GError** error);
void bluetooth_services_adapter_start_discovery (BluetoothServicesAdapter* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
void bluetooth_services_adapter_start_discovery_finish (BluetoothServicesAdapter* self,
                                                        GAsyncResult* _res_,
                                                        GError** error);
void bluetooth_services_adapter_stop_discovery (BluetoothServicesAdapter* self,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
void bluetooth_services_adapter_stop_discovery_finish (BluetoothServicesAdapter* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
gchar** bluetooth_services_adapter_get_UUIDs (BluetoothServicesAdapter* self,
                                              int* result_length1);
gboolean bluetooth_services_adapter_get_discoverable (BluetoothServicesAdapter* self);
void bluetooth_services_adapter_set_discoverable (BluetoothServicesAdapter* self,
                                                  gboolean value);
gboolean bluetooth_services_adapter_get_discovering (BluetoothServicesAdapter* self);
gboolean bluetooth_services_adapter_get_pairable (BluetoothServicesAdapter* self);
void bluetooth_services_adapter_set_pairable (BluetoothServicesAdapter* self,
                                              gboolean value);
gboolean bluetooth_services_adapter_get_powered (BluetoothServicesAdapter* self);
void bluetooth_services_adapter_set_powered (BluetoothServicesAdapter* self,
                                             gboolean value);
gchar* bluetooth_services_adapter_get_address (BluetoothServicesAdapter* self);
gchar* bluetooth_services_adapter_get_alias (BluetoothServicesAdapter* self);
void bluetooth_services_adapter_set_alias (BluetoothServicesAdapter* self,
                                           const gchar* value);
gchar* bluetooth_services_adapter_get_modalias (BluetoothServicesAdapter* self);
gchar* bluetooth_services_adapter_get_name (BluetoothServicesAdapter* self);
guint bluetooth_services_adapter_get_class (BluetoothServicesAdapter* self);
guint bluetooth_services_adapter_get_discoverable_timeout (BluetoothServicesAdapter* self);
guint bluetooth_services_adapter_get_pairable_timeout (BluetoothServicesAdapter* self);
static void bluetooth_services_adapter_proxy_g_signal (GDBusProxy* proxy,
                                                const gchar* sender_name,
                                                const gchar* signal_name,
                                                GVariant* parameters);
static void bluetooth_services_adapter_proxy_remove_device (BluetoothServicesAdapter* self,
                                                     const char* device,
                                                     GError** error);
static void bluetooth_services_adapter_proxy_set_discovery_filter (BluetoothServicesAdapter* self,
                                                            GHashTable* properties,
                                                            GError** error);
static void _vala_g_async_ready_callback (GObject *source_object,
                                   GAsyncResult *res,
                                   void *user_data);
static void bluetooth_services_adapter_proxy_start_discovery_async (BluetoothServicesAdapter* self,
                                                             GAsyncReadyCallback _callback_,
                                                             gpointer _user_data_);
static void bluetooth_services_adapter_proxy_start_discovery_finish (BluetoothServicesAdapter* self,
                                                              GAsyncResult* _res_,
                                                              GError** error);
static void bluetooth_services_adapter_proxy_stop_discovery_async (BluetoothServicesAdapter* self,
                                                            GAsyncReadyCallback _callback_,
                                                            gpointer _user_data_);
static void bluetooth_services_adapter_proxy_stop_discovery_finish (BluetoothServicesAdapter* self,
                                                             GAsyncResult* _res_,
                                                             GError** error);
static gchar** bluetooth_services_adapter_dbus_proxy_get_UUIDs (BluetoothServicesAdapter* self,
                                                         int* result_length1);
static gboolean bluetooth_services_adapter_dbus_proxy_get_discoverable (BluetoothServicesAdapter* self);
static void bluetooth_services_adapter_dbus_proxy_set_discoverable (BluetoothServicesAdapter* self,
                                                             gboolean value);
static gboolean bluetooth_services_adapter_dbus_proxy_get_discovering (BluetoothServicesAdapter* self);
static gboolean bluetooth_services_adapter_dbus_proxy_get_pairable (BluetoothServicesAdapter* self);
static void bluetooth_services_adapter_dbus_proxy_set_pairable (BluetoothServicesAdapter* self,
                                                         gboolean value);
static gboolean bluetooth_services_adapter_dbus_proxy_get_powered (BluetoothServicesAdapter* self);
static void bluetooth_services_adapter_dbus_proxy_set_powered (BluetoothServicesAdapter* self,
                                                        gboolean value);
static gchar* bluetooth_services_adapter_dbus_proxy_get_address (BluetoothServicesAdapter* self);
static gchar* bluetooth_services_adapter_dbus_proxy_get_alias (BluetoothServicesAdapter* self);
static void bluetooth_services_adapter_dbus_proxy_set_alias (BluetoothServicesAdapter* self,
                                                      const gchar* value);
static gchar* bluetooth_services_adapter_dbus_proxy_get_modalias (BluetoothServicesAdapter* self);
static gchar* bluetooth_services_adapter_dbus_proxy_get_name (BluetoothServicesAdapter* self);
static guint bluetooth_services_adapter_dbus_proxy_get_class (BluetoothServicesAdapter* self);
static guint bluetooth_services_adapter_dbus_proxy_get_discoverable_timeout (BluetoothServicesAdapter* self);
static guint bluetooth_services_adapter_dbus_proxy_get_pairable_timeout (BluetoothServicesAdapter* self);
static void bluetooth_services_adapter_proxy_bluetooth_services_adapter_interface_init (BluetoothServicesAdapterIface* iface);
static void _dbus_bluetooth_services_adapter_remove_device (BluetoothServicesAdapter* self,
                                                     GVariant* _parameters_,
                                                     GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_adapter_set_discovery_filter (BluetoothServicesAdapter* self,
                                                            GVariant* _parameters_,
                                                            GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_adapter_start_discovery (BluetoothServicesAdapter* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_adapter_start_discovery_ready (GObject * source_object,
                                                             GAsyncResult * _res_,
                                                             gpointer _user_data_);
static void _dbus_bluetooth_services_adapter_stop_discovery (BluetoothServicesAdapter* self,
                                                      GVariant* _parameters_,
                                                      GDBusMethodInvocation* invocation);
static void _dbus_bluetooth_services_adapter_stop_discovery_ready (GObject * source_object,
                                                            GAsyncResult * _res_,
                                                            gpointer _user_data_);
static void bluetooth_services_adapter_dbus_interface_method_call (GDBusConnection* connection,
                                                            const gchar* sender,
                                                            const gchar* object_path,
                                                            const gchar* interface_name,
                                                            const gchar* method_name,
                                                            GVariant* parameters,
                                                            GDBusMethodInvocation* invocation,
                                                            gpointer user_data);
static GVariant* bluetooth_services_adapter_dbus_interface_get_property (GDBusConnection* connection,
                                                                  const gchar* sender,
                                                                  const gchar* object_path,
                                                                  const gchar* interface_name,
                                                                  const gchar* property_name,
                                                                  GError** error,
                                                                  gpointer user_data);
static GVariant* _dbus_bluetooth_services_adapter_get_UUIDs (BluetoothServicesAdapter* self);
static GVariant* _dbus_bluetooth_services_adapter_get_discoverable (BluetoothServicesAdapter* self);
static GVariant* _dbus_bluetooth_services_adapter_get_discovering (BluetoothServicesAdapter* self);
static GVariant* _dbus_bluetooth_services_adapter_get_pairable (BluetoothServicesAdapter* self);
static GVariant* _dbus_bluetooth_services_adapter_get_powered (BluetoothServicesAdapter* self);
static GVariant* _dbus_bluetooth_services_adapter_get_address (BluetoothServicesAdapter* self);
static GVariant* _dbus_bluetooth_services_adapter_get_alias (BluetoothServicesAdapter* self);
static GVariant* _dbus_bluetooth_services_adapter_get_modalias (BluetoothServicesAdapter* self);
static GVariant* _dbus_bluetooth_services_adapter_get_name (BluetoothServicesAdapter* self);
static GVariant* _dbus_bluetooth_services_adapter_get_class (BluetoothServicesAdapter* self);
static GVariant* _dbus_bluetooth_services_adapter_get_discoverable_timeout (BluetoothServicesAdapter* self);
static GVariant* _dbus_bluetooth_services_adapter_get_pairable_timeout (BluetoothServicesAdapter* self);
static gboolean bluetooth_services_adapter_dbus_interface_set_property (GDBusConnection* connection,
                                                                 const gchar* sender,
                                                                 const gchar* object_path,
                                                                 const gchar* interface_name,
                                                                 const gchar* property_name,
                                                                 GVariant* value,
                                                                 GError** error,
                                                                 gpointer user_data);
static void _dbus_bluetooth_services_adapter_set_discoverable (BluetoothServicesAdapter* self,
                                                        GVariant* _value);
static void _dbus_bluetooth_services_adapter_set_pairable (BluetoothServicesAdapter* self,
                                                    GVariant* _value);
static void _dbus_bluetooth_services_adapter_set_powered (BluetoothServicesAdapter* self,
                                                   GVariant* _value);
static void _dbus_bluetooth_services_adapter_set_alias (BluetoothServicesAdapter* self,
                                                 GVariant* _value);
static void _bluetooth_services_adapter_unregister_object (gpointer user_data);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const GDBusArgInfo _bluetooth_services_adapter_dbus_arg_info_remove_device_device = {-1, "device", "o", NULL};
static const GDBusArgInfo * const _bluetooth_services_adapter_dbus_arg_info_remove_device_in[] = {&_bluetooth_services_adapter_dbus_arg_info_remove_device_device, NULL};
static const GDBusArgInfo * const _bluetooth_services_adapter_dbus_arg_info_remove_device_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_adapter_dbus_method_info_remove_device = {-1, "RemoveDevice", (GDBusArgInfo **) (&_bluetooth_services_adapter_dbus_arg_info_remove_device_in), (GDBusArgInfo **) (&_bluetooth_services_adapter_dbus_arg_info_remove_device_out), NULL};
static const GDBusArgInfo _bluetooth_services_adapter_dbus_arg_info_set_discovery_filter_properties = {-1, "properties", "a{sv}", NULL};
static const GDBusArgInfo * const _bluetooth_services_adapter_dbus_arg_info_set_discovery_filter_in[] = {&_bluetooth_services_adapter_dbus_arg_info_set_discovery_filter_properties, NULL};
static const GDBusArgInfo * const _bluetooth_services_adapter_dbus_arg_info_set_discovery_filter_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_adapter_dbus_method_info_set_discovery_filter = {-1, "SetDiscoveryFilter", (GDBusArgInfo **) (&_bluetooth_services_adapter_dbus_arg_info_set_discovery_filter_in), (GDBusArgInfo **) (&_bluetooth_services_adapter_dbus_arg_info_set_discovery_filter_out), NULL};
static const GDBusArgInfo * const _bluetooth_services_adapter_dbus_arg_info_start_discovery_in[] = {NULL};
static const GDBusArgInfo * const _bluetooth_services_adapter_dbus_arg_info_start_discovery_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_adapter_dbus_method_info_start_discovery = {-1, "StartDiscovery", (GDBusArgInfo **) (&_bluetooth_services_adapter_dbus_arg_info_start_discovery_in), (GDBusArgInfo **) (&_bluetooth_services_adapter_dbus_arg_info_start_discovery_out), NULL};
static const GDBusArgInfo * const _bluetooth_services_adapter_dbus_arg_info_stop_discovery_in[] = {NULL};
static const GDBusArgInfo * const _bluetooth_services_adapter_dbus_arg_info_stop_discovery_out[] = {NULL};
static const GDBusMethodInfo _bluetooth_services_adapter_dbus_method_info_stop_discovery = {-1, "StopDiscovery", (GDBusArgInfo **) (&_bluetooth_services_adapter_dbus_arg_info_stop_discovery_in), (GDBusArgInfo **) (&_bluetooth_services_adapter_dbus_arg_info_stop_discovery_out), NULL};
static const GDBusMethodInfo * const _bluetooth_services_adapter_dbus_method_info[] = {&_bluetooth_services_adapter_dbus_method_info_remove_device, &_bluetooth_services_adapter_dbus_method_info_set_discovery_filter, &_bluetooth_services_adapter_dbus_method_info_start_discovery, &_bluetooth_services_adapter_dbus_method_info_stop_discovery, NULL};
static const GDBusSignalInfo * const _bluetooth_services_adapter_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _bluetooth_services_adapter_dbus_property_info_UUIDs = {-1, "UUIDs", "as", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _bluetooth_services_adapter_dbus_property_info_discoverable = {-1, "Discoverable", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _bluetooth_services_adapter_dbus_property_info_discovering = {-1, "Discovering", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _bluetooth_services_adapter_dbus_property_info_pairable = {-1, "Pairable", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _bluetooth_services_adapter_dbus_property_info_powered = {-1, "Powered", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _bluetooth_services_adapter_dbus_property_info_address = {-1, "Address", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _bluetooth_services_adapter_dbus_property_info_alias = {-1, "Alias", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE | G_DBUS_PROPERTY_INFO_FLAGS_WRITABLE, NULL};
static const GDBusPropertyInfo _bluetooth_services_adapter_dbus_property_info_modalias = {-1, "Modalias", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _bluetooth_services_adapter_dbus_property_info_name = {-1, "Name", "s", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _bluetooth_services_adapter_dbus_property_info_class = {-1, "Class", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _bluetooth_services_adapter_dbus_property_info_discoverable_timeout = {-1, "DiscoverableTimeout", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _bluetooth_services_adapter_dbus_property_info_pairable_timeout = {-1, "PairableTimeout", "u", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _bluetooth_services_adapter_dbus_property_info[] = {&_bluetooth_services_adapter_dbus_property_info_UUIDs, &_bluetooth_services_adapter_dbus_property_info_discoverable, &_bluetooth_services_adapter_dbus_property_info_discovering, &_bluetooth_services_adapter_dbus_property_info_pairable, &_bluetooth_services_adapter_dbus_property_info_powered, &_bluetooth_services_adapter_dbus_property_info_address, &_bluetooth_services_adapter_dbus_property_info_alias, &_bluetooth_services_adapter_dbus_property_info_modalias, &_bluetooth_services_adapter_dbus_property_info_name, &_bluetooth_services_adapter_dbus_property_info_class, &_bluetooth_services_adapter_dbus_property_info_discoverable_timeout, &_bluetooth_services_adapter_dbus_property_info_pairable_timeout, NULL};
static const GDBusInterfaceInfo _bluetooth_services_adapter_dbus_interface_info = {-1, "org.bluez.Adapter1", (GDBusMethodInfo **) (&_bluetooth_services_adapter_dbus_method_info), (GDBusSignalInfo **) (&_bluetooth_services_adapter_dbus_signal_info), (GDBusPropertyInfo **) (&_bluetooth_services_adapter_dbus_property_info), NULL};
static const GDBusInterfaceVTable _bluetooth_services_adapter_dbus_interface_vtable = {bluetooth_services_adapter_dbus_interface_method_call, bluetooth_services_adapter_dbus_interface_get_property, bluetooth_services_adapter_dbus_interface_set_property};

void
bluetooth_services_adapter_remove_device (BluetoothServicesAdapter* self,
                                          const char* device,
                                          GError** error)
{
#line 23 "../src/Services/Adapter.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/Services/Adapter.vala"
	BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->remove_device (self, device, error);
#line 287 "Adapter.c"
}


void
bluetooth_services_adapter_set_discovery_filter (BluetoothServicesAdapter* self,
                                                 GHashTable* properties,
                                                 GError** error)
{
#line 24 "../src/Services/Adapter.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Services/Adapter.vala"
	BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->set_discovery_filter (self, properties, error);
#line 300 "Adapter.c"
}


void
bluetooth_services_adapter_start_discovery (BluetoothServicesAdapter* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
#line 22 "../src/Services/Adapter.vala"
	BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->start_discovery (self, _callback_, _user_data_);
#line 311 "Adapter.c"
}


void
bluetooth_services_adapter_start_discovery_finish (BluetoothServicesAdapter* self,
                                                   GAsyncResult* _res_,
                                                   GError** error)
{
#line 22 "../src/Services/Adapter.vala"
	BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->start_discovery_finish (self, _res_, error);
#line 322 "Adapter.c"
}


void
bluetooth_services_adapter_stop_discovery (BluetoothServicesAdapter* self,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
#line 22 "../src/Services/Adapter.vala"
	BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->stop_discovery (self, _callback_, _user_data_);
#line 333 "Adapter.c"
}


void
bluetooth_services_adapter_stop_discovery_finish (BluetoothServicesAdapter* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
#line 22 "../src/Services/Adapter.vala"
	BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->stop_discovery_finish (self, _res_, error);
#line 344 "Adapter.c"
}


gchar**
bluetooth_services_adapter_get_UUIDs (BluetoothServicesAdapter* self,
                                      int* result_length1)
{
#line 28 "../src/Services/Adapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Services/Adapter.vala"
	return BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->get_UUIDs (self, result_length1);
#line 356 "Adapter.c"
}


gboolean
bluetooth_services_adapter_get_discoverable (BluetoothServicesAdapter* self)
{
#line 29 "../src/Services/Adapter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "../src/Services/Adapter.vala"
	return BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->get_discoverable (self);
#line 367 "Adapter.c"
}


void
bluetooth_services_adapter_set_discoverable (BluetoothServicesAdapter* self,
                                             gboolean value)
{
#line 29 "../src/Services/Adapter.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Services/Adapter.vala"
	BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->set_discoverable (self, value);
#line 379 "Adapter.c"
}


gboolean
bluetooth_services_adapter_get_discovering (BluetoothServicesAdapter* self)
{
#line 30 "../src/Services/Adapter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30 "../src/Services/Adapter.vala"
	return BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->get_discovering (self);
#line 390 "Adapter.c"
}


gboolean
bluetooth_services_adapter_get_pairable (BluetoothServicesAdapter* self)
{
#line 31 "../src/Services/Adapter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31 "../src/Services/Adapter.vala"
	return BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->get_pairable (self);
#line 401 "Adapter.c"
}


void
bluetooth_services_adapter_set_pairable (BluetoothServicesAdapter* self,
                                         gboolean value)
{
#line 31 "../src/Services/Adapter.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Services/Adapter.vala"
	BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->set_pairable (self, value);
#line 413 "Adapter.c"
}


gboolean
bluetooth_services_adapter_get_powered (BluetoothServicesAdapter* self)
{
#line 32 "../src/Services/Adapter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../src/Services/Adapter.vala"
	return BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->get_powered (self);
#line 424 "Adapter.c"
}


void
bluetooth_services_adapter_set_powered (BluetoothServicesAdapter* self,
                                        gboolean value)
{
#line 32 "../src/Services/Adapter.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Services/Adapter.vala"
	BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->set_powered (self, value);
#line 436 "Adapter.c"
}


gchar*
bluetooth_services_adapter_get_address (BluetoothServicesAdapter* self)
{
#line 33 "../src/Services/Adapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/Services/Adapter.vala"
	return BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->get_address (self);
#line 447 "Adapter.c"
}


gchar*
bluetooth_services_adapter_get_alias (BluetoothServicesAdapter* self)
{
#line 34 "../src/Services/Adapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Services/Adapter.vala"
	return BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->get_alias (self);
#line 458 "Adapter.c"
}


void
bluetooth_services_adapter_set_alias (BluetoothServicesAdapter* self,
                                      const gchar* value)
{
#line 34 "../src/Services/Adapter.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Services/Adapter.vala"
	BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->set_alias (self, value);
#line 470 "Adapter.c"
}


gchar*
bluetooth_services_adapter_get_modalias (BluetoothServicesAdapter* self)
{
#line 35 "../src/Services/Adapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Services/Adapter.vala"
	return BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->get_modalias (self);
#line 481 "Adapter.c"
}


gchar*
bluetooth_services_adapter_get_name (BluetoothServicesAdapter* self)
{
#line 36 "../src/Services/Adapter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/Services/Adapter.vala"
	return BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->get_name (self);
#line 492 "Adapter.c"
}


guint
bluetooth_services_adapter_get_class (BluetoothServicesAdapter* self)
{
#line 37 "../src/Services/Adapter.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 37 "../src/Services/Adapter.vala"
	return BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->get_class (self);
#line 503 "Adapter.c"
}


guint
bluetooth_services_adapter_get_discoverable_timeout (BluetoothServicesAdapter* self)
{
#line 38 "../src/Services/Adapter.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 38 "../src/Services/Adapter.vala"
	return BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->get_discoverable_timeout (self);
#line 514 "Adapter.c"
}


guint
bluetooth_services_adapter_get_pairable_timeout (BluetoothServicesAdapter* self)
{
#line 39 "../src/Services/Adapter.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 39 "../src/Services/Adapter.vala"
	return BLUETOOTH_SERVICES_ADAPTER_GET_INTERFACE (self)->get_pairable_timeout (self);
#line 525 "Adapter.c"
}


static void
bluetooth_services_adapter_default_init (BluetoothServicesAdapterIface * iface)
{
}


GType
bluetooth_services_adapter_get_type (void)
{
	static volatile gsize bluetooth_services_adapter_type_id__volatile = 0;
	if (g_once_init_enter (&bluetooth_services_adapter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (BluetoothServicesAdapterIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_services_adapter_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType bluetooth_services_adapter_type_id;
		bluetooth_services_adapter_type_id = g_type_register_static (G_TYPE_INTERFACE, "BluetoothServicesAdapter", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (bluetooth_services_adapter_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (bluetooth_services_adapter_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) bluetooth_services_adapter_proxy_get_type);
		g_type_set_qdata (bluetooth_services_adapter_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.bluez.Adapter1");
		g_type_set_qdata (bluetooth_services_adapter_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_bluetooth_services_adapter_dbus_interface_info));
		g_type_set_qdata (bluetooth_services_adapter_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) bluetooth_services_adapter_register_object);
		g_once_init_leave (&bluetooth_services_adapter_type_id__volatile, bluetooth_services_adapter_type_id);
	}
	return bluetooth_services_adapter_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (BluetoothServicesAdapterProxy, bluetooth_services_adapter_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (BLUETOOTH_SERVICES_TYPE_ADAPTER, bluetooth_services_adapter_proxy_bluetooth_services_adapter_interface_init) )
static void
bluetooth_services_adapter_proxy_class_init (BluetoothServicesAdapterProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = bluetooth_services_adapter_proxy_g_signal;
}


static void
bluetooth_services_adapter_proxy_g_signal (GDBusProxy* proxy,
                                           const gchar* sender_name,
                                           const gchar* signal_name,
                                           GVariant* parameters)
{
}


static void
bluetooth_services_adapter_proxy_init (BluetoothServicesAdapterProxy* self)
{
}


static void
bluetooth_services_adapter_proxy_remove_device (BluetoothServicesAdapter* self,
                                                const char* device,
                                                GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.Adapter1", "RemoveDevice");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_object_path (device));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void
bluetooth_services_adapter_proxy_set_discovery_filter (BluetoothServicesAdapter* self,
                                                       GHashTable* properties,
                                                       GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GVariantBuilder _tmp67_;
	GHashTableIter _tmp68_;
	gpointer _tmp69_;
	gpointer _tmp70_;
	GDBusMessage *_reply_message;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.Adapter1", "SetDiscoveryFilter");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_hash_table_iter_init (&_tmp68_, properties);
	g_variant_builder_init (&_tmp67_, G_VARIANT_TYPE ("a{sv}"));
	while (g_hash_table_iter_next (&_tmp68_, &_tmp69_, &_tmp70_)) {
		gchar* _key;
		GVariant* _value;
		_key = (gchar*) _tmp69_;
		_value = (GVariant*) _tmp70_;
		g_variant_builder_add (&_tmp67_, "{?*}", g_variant_new_string (_key), g_variant_new_variant (_value));
	}
	g_variant_builder_add_value (&_arguments_builder, g_variant_builder_end (&_tmp67_));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void
_vala_g_async_ready_callback (GObject *source_object,
                              GAsyncResult *res,
                              void *user_data)
{
	g_task_return_pointer (user_data, g_object_ref (res), g_object_unref);
	g_object_unref (user_data);
}


static void
bluetooth_services_adapter_proxy_start_discovery_async (BluetoothServicesAdapter* self,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.Adapter1", "StartDiscovery");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_task_new ((GObject *) self, NULL, _callback_, _user_data_));
	g_object_unref (_message);
}


static void
bluetooth_services_adapter_proxy_start_discovery_finish (BluetoothServicesAdapter* self,
                                                         GAsyncResult* _res_,
                                                         GError** error)
{
	GAsyncResult *_inner_res;
	GDBusMessage *_reply_message;
	_inner_res = g_task_propagate_pointer ((GTask *) _res_, NULL);
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), _inner_res, error);
	g_object_unref (_inner_res);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void
bluetooth_services_adapter_proxy_stop_discovery_async (BluetoothServicesAdapter* self,
                                                       GAsyncReadyCallback _callback_,
                                                       gpointer _user_data_)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.bluez.Adapter1", "StopDiscovery");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_task_new ((GObject *) self, NULL, _callback_, _user_data_));
	g_object_unref (_message);
}


static void
bluetooth_services_adapter_proxy_stop_discovery_finish (BluetoothServicesAdapter* self,
                                                        GAsyncResult* _res_,
                                                        GError** error)
{
	GAsyncResult *_inner_res;
	GDBusMessage *_reply_message;
	_inner_res = g_task_propagate_pointer ((GTask *) _res_, NULL);
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), _inner_res, error);
	g_object_unref (_inner_res);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static gchar**
bluetooth_services_adapter_dbus_proxy_get_UUIDs (BluetoothServicesAdapter* self,
                                                 int* result_length1)
{
	GVariant *_inner_reply;
	gchar** _result;
	int _result_length1;
	gchar** _tmp71_;
	int _tmp71__length;
	int _tmp71__size;
	int _tmp71__length1;
	GVariantIter _tmp72_;
	GVariant* _tmp73_;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "UUIDs");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("UUIDs"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result_length1 = 0;
	_tmp71_ = g_new (gchar*, 5);
	_tmp71__length = 0;
	_tmp71__size = 4;
	_tmp71__length1 = 0;
	g_variant_iter_init (&_tmp72_, _inner_reply);
	for (; (_tmp73_ = g_variant_iter_next_value (&_tmp72_)) != NULL; _tmp71__length1++) {
		if (_tmp71__size == _tmp71__length) {
			_tmp71__size = 2 * _tmp71__size;
			_tmp71_ = g_renew (gchar*, _tmp71_, _tmp71__size + 1);
		}
		_tmp71_[_tmp71__length++] = g_variant_dup_string (_tmp73_, NULL);
		g_variant_unref (_tmp73_);
	}
	_result_length1 = _tmp71__length1;
	_tmp71_[_tmp71__length] = NULL;
	_result = _tmp71_;
	*result_length1 = _result_length1;
	g_variant_unref (_inner_reply);
	return _result;
}


static gboolean
bluetooth_services_adapter_dbus_proxy_get_discoverable (BluetoothServicesAdapter* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Discoverable");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Discoverable"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp74_ = FALSE;
			return _tmp74_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void
bluetooth_services_adapter_dbus_proxy_set_discoverable (BluetoothServicesAdapter* self,
                                                        gboolean value)
{
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Discoverable"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gboolean
bluetooth_services_adapter_dbus_proxy_get_discovering (BluetoothServicesAdapter* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Discovering");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Discovering"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp75_ = FALSE;
			return _tmp75_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static gboolean
bluetooth_services_adapter_dbus_proxy_get_pairable (BluetoothServicesAdapter* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Pairable");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Pairable"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp76_ = FALSE;
			return _tmp76_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void
bluetooth_services_adapter_dbus_proxy_set_pairable (BluetoothServicesAdapter* self,
                                                    gboolean value)
{
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Pairable"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gboolean
bluetooth_services_adapter_dbus_proxy_get_powered (BluetoothServicesAdapter* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Powered");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Powered"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp77_ = FALSE;
			return _tmp77_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void
bluetooth_services_adapter_dbus_proxy_set_powered (BluetoothServicesAdapter* self,
                                                   gboolean value)
{
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Powered"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gchar*
bluetooth_services_adapter_dbus_proxy_get_address (BluetoothServicesAdapter* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Address");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Address"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static gchar*
bluetooth_services_adapter_dbus_proxy_get_alias (BluetoothServicesAdapter* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Alias");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Alias"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static void
bluetooth_services_adapter_dbus_proxy_set_alias (BluetoothServicesAdapter* self,
                                                 const gchar* value)
{
	GVariant *_arguments;
	GVariant *_reply;
	GVariantBuilder _arguments_builder;
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Alias"));
	g_variant_builder_open (&_arguments_builder, G_VARIANT_TYPE_VARIANT);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (value));
	g_variant_builder_close (&_arguments_builder);
	_arguments = g_variant_builder_end (&_arguments_builder);
	_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Set", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
	if (!_reply) {
		return;
	}
	g_variant_unref (_reply);
}


static gchar*
bluetooth_services_adapter_dbus_proxy_get_modalias (BluetoothServicesAdapter* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Modalias");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Modalias"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static gchar*
bluetooth_services_adapter_dbus_proxy_get_name (BluetoothServicesAdapter* self)
{
	GVariant *_inner_reply;
	gchar* _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Name");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Name"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			return NULL;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_dup_string (_inner_reply, NULL);
	g_variant_unref (_inner_reply);
	return _result;
}


static guint
bluetooth_services_adapter_dbus_proxy_get_class (BluetoothServicesAdapter* self)
{
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "Class");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("Class"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint _tmp78_ = 0U;
			return _tmp78_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static guint
bluetooth_services_adapter_dbus_proxy_get_discoverable_timeout (BluetoothServicesAdapter* self)
{
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "DiscoverableTimeout");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("DiscoverableTimeout"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint _tmp79_ = 0U;
			return _tmp79_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static guint
bluetooth_services_adapter_dbus_proxy_get_pairable_timeout (BluetoothServicesAdapter* self)
{
	GVariant *_inner_reply;
	guint _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "PairableTimeout");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("org.bluez.Adapter1"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("PairableTimeout"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			guint _tmp80_ = 0U;
			return _tmp80_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_uint32 (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}


static void
bluetooth_services_adapter_proxy_bluetooth_services_adapter_interface_init (BluetoothServicesAdapterIface* iface)
{
	iface->remove_device = bluetooth_services_adapter_proxy_remove_device;
	iface->set_discovery_filter = bluetooth_services_adapter_proxy_set_discovery_filter;
	iface->start_discovery = bluetooth_services_adapter_proxy_start_discovery_async;
	iface->start_discovery_finish = bluetooth_services_adapter_proxy_start_discovery_finish;
	iface->stop_discovery = bluetooth_services_adapter_proxy_stop_discovery_async;
	iface->stop_discovery_finish = bluetooth_services_adapter_proxy_stop_discovery_finish;
	iface->get_UUIDs = bluetooth_services_adapter_dbus_proxy_get_UUIDs;
	iface->get_discoverable = bluetooth_services_adapter_dbus_proxy_get_discoverable;
	iface->set_discoverable = bluetooth_services_adapter_dbus_proxy_set_discoverable;
	iface->get_discovering = bluetooth_services_adapter_dbus_proxy_get_discovering;
	iface->get_pairable = bluetooth_services_adapter_dbus_proxy_get_pairable;
	iface->set_pairable = bluetooth_services_adapter_dbus_proxy_set_pairable;
	iface->get_powered = bluetooth_services_adapter_dbus_proxy_get_powered;
	iface->set_powered = bluetooth_services_adapter_dbus_proxy_set_powered;
	iface->get_address = bluetooth_services_adapter_dbus_proxy_get_address;
	iface->get_alias = bluetooth_services_adapter_dbus_proxy_get_alias;
	iface->set_alias = bluetooth_services_adapter_dbus_proxy_set_alias;
	iface->get_modalias = bluetooth_services_adapter_dbus_proxy_get_modalias;
	iface->get_name = bluetooth_services_adapter_dbus_proxy_get_name;
	iface->get_class = bluetooth_services_adapter_dbus_proxy_get_class;
	iface->get_discoverable_timeout = bluetooth_services_adapter_dbus_proxy_get_discoverable_timeout;
	iface->get_pairable_timeout = bluetooth_services_adapter_dbus_proxy_get_pairable_timeout;
}


static void
_dbus_bluetooth_services_adapter_remove_device (BluetoothServicesAdapter* self,
                                                GVariant* _parameters_,
                                                GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	char* device = NULL;
	GVariant* _tmp81_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp81_ = g_variant_iter_next_value (&_arguments_iter);
	device = g_variant_dup_string (_tmp81_, NULL);
	g_variant_unref (_tmp81_);
	bluetooth_services_adapter_remove_device (self, device, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_free0 (device);
}


static void
_dbus_bluetooth_services_adapter_set_discovery_filter (BluetoothServicesAdapter* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GHashTable* properties = NULL;
	GVariant* _tmp82_;
	GHashTable* _tmp83_;
	GVariantIter _tmp84_;
	GVariant* _tmp85_;
	GVariant* _tmp86_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp82_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp83_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, (GDestroyNotify) g_variant_unref);
	g_variant_iter_init (&_tmp84_, _tmp82_);
	while (g_variant_iter_loop (&_tmp84_, "{?*}", &_tmp85_, &_tmp86_)) {
		g_hash_table_insert (_tmp83_, g_variant_dup_string (_tmp85_, NULL), g_variant_get_variant (_tmp86_));
	}
	properties = _tmp83_;
	g_variant_unref (_tmp82_);
	bluetooth_services_adapter_set_discovery_filter (self, properties, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_g_hash_table_unref0 (properties);
}


static void
_dbus_bluetooth_services_adapter_start_discovery (BluetoothServicesAdapter* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	BluetoothServicesAdapterStartDiscoveryReadyData* _ready_data;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (BluetoothServicesAdapterStartDiscoveryReadyData);
	_ready_data->_invocation_ = invocation;
	bluetooth_services_adapter_start_discovery (self, (GAsyncReadyCallback) _dbus_bluetooth_services_adapter_start_discovery_ready, _ready_data);
}


static void
_dbus_bluetooth_services_adapter_start_discovery_ready (GObject * source_object,
                                                        GAsyncResult * _res_,
                                                        gpointer _user_data_)
{
	BluetoothServicesAdapterStartDiscoveryReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	bluetooth_services_adapter_start_discovery_finish ((BluetoothServicesAdapter*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	g_slice_free (BluetoothServicesAdapterStartDiscoveryReadyData, _ready_data);
}


static void
_dbus_bluetooth_services_adapter_stop_discovery (BluetoothServicesAdapter* self,
                                                 GVariant* _parameters_,
                                                 GDBusMethodInvocation* invocation)
{
	GVariantIter _arguments_iter;
	BluetoothServicesAdapterStopDiscoveryReadyData* _ready_data;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_ready_data = g_slice_new0 (BluetoothServicesAdapterStopDiscoveryReadyData);
	_ready_data->_invocation_ = invocation;
	bluetooth_services_adapter_stop_discovery (self, (GAsyncReadyCallback) _dbus_bluetooth_services_adapter_stop_discovery_ready, _ready_data);
}


static void
_dbus_bluetooth_services_adapter_stop_discovery_ready (GObject * source_object,
                                                       GAsyncResult * _res_,
                                                       gpointer _user_data_)
{
	BluetoothServicesAdapterStopDiscoveryReadyData* _ready_data;
	GDBusMethodInvocation* invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	_ready_data = _user_data_;
	invocation = _ready_data->_invocation_;
	bluetooth_services_adapter_stop_discovery_finish ((BluetoothServicesAdapter*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		g_error_free (error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	g_slice_free (BluetoothServicesAdapterStopDiscoveryReadyData, _ready_data);
}


static void
bluetooth_services_adapter_dbus_interface_method_call (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* method_name,
                                                       GVariant* parameters,
                                                       GDBusMethodInvocation* invocation,
                                                       gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "RemoveDevice") == 0) {
		_dbus_bluetooth_services_adapter_remove_device (object, parameters, invocation);
	} else if (strcmp (method_name, "SetDiscoveryFilter") == 0) {
		_dbus_bluetooth_services_adapter_set_discovery_filter (object, parameters, invocation);
	} else if (strcmp (method_name, "StartDiscovery") == 0) {
		_dbus_bluetooth_services_adapter_start_discovery (object, parameters, invocation);
	} else if (strcmp (method_name, "StopDiscovery") == 0) {
		_dbus_bluetooth_services_adapter_stop_discovery (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant*
_dbus_bluetooth_services_adapter_get_UUIDs (BluetoothServicesAdapter* self)
{
	gchar** result;
	int result_length1 = 0;
	GVariant* _reply;
	gchar** _tmp87_;
	GVariantBuilder _tmp88_;
	int _tmp89_;
	result = bluetooth_services_adapter_get_UUIDs (self, &result_length1);
	_tmp87_ = result;
	g_variant_builder_init (&_tmp88_, G_VARIANT_TYPE ("as"));
	for (_tmp89_ = 0; _tmp89_ < result_length1; _tmp89_++) {
		g_variant_builder_add_value (&_tmp88_, g_variant_new_string (*_tmp87_));
		_tmp87_++;
	}
	_reply = g_variant_builder_end (&_tmp88_);
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	return _reply;
}


static GVariant*
_dbus_bluetooth_services_adapter_get_discoverable (BluetoothServicesAdapter* self)
{
	gboolean result;
	GVariant* _reply;
	result = bluetooth_services_adapter_get_discoverable (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant*
_dbus_bluetooth_services_adapter_get_discovering (BluetoothServicesAdapter* self)
{
	gboolean result;
	GVariant* _reply;
	result = bluetooth_services_adapter_get_discovering (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant*
_dbus_bluetooth_services_adapter_get_pairable (BluetoothServicesAdapter* self)
{
	gboolean result;
	GVariant* _reply;
	result = bluetooth_services_adapter_get_pairable (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant*
_dbus_bluetooth_services_adapter_get_powered (BluetoothServicesAdapter* self)
{
	gboolean result;
	GVariant* _reply;
	result = bluetooth_services_adapter_get_powered (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}


static GVariant*
_dbus_bluetooth_services_adapter_get_address (BluetoothServicesAdapter* self)
{
	gchar* result;
	GVariant* _reply;
	result = bluetooth_services_adapter_get_address (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant*
_dbus_bluetooth_services_adapter_get_alias (BluetoothServicesAdapter* self)
{
	gchar* result;
	GVariant* _reply;
	result = bluetooth_services_adapter_get_alias (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant*
_dbus_bluetooth_services_adapter_get_modalias (BluetoothServicesAdapter* self)
{
	gchar* result;
	GVariant* _reply;
	result = bluetooth_services_adapter_get_modalias (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant*
_dbus_bluetooth_services_adapter_get_name (BluetoothServicesAdapter* self)
{
	gchar* result;
	GVariant* _reply;
	result = bluetooth_services_adapter_get_name (self);
	_reply = g_variant_new_string (result);
	_g_free0 (result);
	return _reply;
}


static GVariant*
_dbus_bluetooth_services_adapter_get_class (BluetoothServicesAdapter* self)
{
	guint result;
	GVariant* _reply;
	result = bluetooth_services_adapter_get_class (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}


static GVariant*
_dbus_bluetooth_services_adapter_get_discoverable_timeout (BluetoothServicesAdapter* self)
{
	guint result;
	GVariant* _reply;
	result = bluetooth_services_adapter_get_discoverable_timeout (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}


static GVariant*
_dbus_bluetooth_services_adapter_get_pairable_timeout (BluetoothServicesAdapter* self)
{
	guint result;
	GVariant* _reply;
	result = bluetooth_services_adapter_get_pairable_timeout (self);
	_reply = g_variant_new_uint32 (result);
	return _reply;
}


static GVariant*
bluetooth_services_adapter_dbus_interface_get_property (GDBusConnection* connection,
                                                        const gchar* sender,
                                                        const gchar* object_path,
                                                        const gchar* interface_name,
                                                        const gchar* property_name,
                                                        GError** error,
                                                        gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "UUIDs") == 0) {
		return _dbus_bluetooth_services_adapter_get_UUIDs (object);
	} else if (strcmp (property_name, "Discoverable") == 0) {
		return _dbus_bluetooth_services_adapter_get_discoverable (object);
	} else if (strcmp (property_name, "Discovering") == 0) {
		return _dbus_bluetooth_services_adapter_get_discovering (object);
	} else if (strcmp (property_name, "Pairable") == 0) {
		return _dbus_bluetooth_services_adapter_get_pairable (object);
	} else if (strcmp (property_name, "Powered") == 0) {
		return _dbus_bluetooth_services_adapter_get_powered (object);
	} else if (strcmp (property_name, "Address") == 0) {
		return _dbus_bluetooth_services_adapter_get_address (object);
	} else if (strcmp (property_name, "Alias") == 0) {
		return _dbus_bluetooth_services_adapter_get_alias (object);
	} else if (strcmp (property_name, "Modalias") == 0) {
		return _dbus_bluetooth_services_adapter_get_modalias (object);
	} else if (strcmp (property_name, "Name") == 0) {
		return _dbus_bluetooth_services_adapter_get_name (object);
	} else if (strcmp (property_name, "Class") == 0) {
		return _dbus_bluetooth_services_adapter_get_class (object);
	} else if (strcmp (property_name, "DiscoverableTimeout") == 0) {
		return _dbus_bluetooth_services_adapter_get_discoverable_timeout (object);
	} else if (strcmp (property_name, "PairableTimeout") == 0) {
		return _dbus_bluetooth_services_adapter_get_pairable_timeout (object);
	}
	return NULL;
}


static void
_dbus_bluetooth_services_adapter_set_discoverable (BluetoothServicesAdapter* self,
                                                   GVariant* _value)
{
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	bluetooth_services_adapter_set_discoverable (self, value);
}


static void
_dbus_bluetooth_services_adapter_set_pairable (BluetoothServicesAdapter* self,
                                               GVariant* _value)
{
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	bluetooth_services_adapter_set_pairable (self, value);
}


static void
_dbus_bluetooth_services_adapter_set_powered (BluetoothServicesAdapter* self,
                                              GVariant* _value)
{
	gboolean value = FALSE;
	value = g_variant_get_boolean (_value);
	bluetooth_services_adapter_set_powered (self, value);
}


static void
_dbus_bluetooth_services_adapter_set_alias (BluetoothServicesAdapter* self,
                                            GVariant* _value)
{
	gchar* value = NULL;
	value = g_variant_dup_string (_value, NULL);
	bluetooth_services_adapter_set_alias (self, value);
	_g_free0 (value);
}


static gboolean
bluetooth_services_adapter_dbus_interface_set_property (GDBusConnection* connection,
                                                        const gchar* sender,
                                                        const gchar* object_path,
                                                        const gchar* interface_name,
                                                        const gchar* property_name,
                                                        GVariant* value,
                                                        GError** error,
                                                        gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "Discoverable") == 0) {
		_dbus_bluetooth_services_adapter_set_discoverable (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Pairable") == 0) {
		_dbus_bluetooth_services_adapter_set_pairable (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Powered") == 0) {
		_dbus_bluetooth_services_adapter_set_powered (object, value);
		return TRUE;
	} else if (strcmp (property_name, "Alias") == 0) {
		_dbus_bluetooth_services_adapter_set_alias (object, value);
		return TRUE;
	}
	return FALSE;
}


guint
bluetooth_services_adapter_register_object (gpointer object,
                                            GDBusConnection* connection,
                                            const gchar* path,
                                            GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_bluetooth_services_adapter_dbus_interface_info), &_bluetooth_services_adapter_dbus_interface_vtable, data, _bluetooth_services_adapter_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void
_bluetooth_services_adapter_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



